iOS14以上,UITableViewCell中的控件,点击无效

适配iOS14系统,发现很多列表中的小按钮点击事件不响应,iOS14以下的系统没有异常

这是因为将控件直接添加到cell上导致(swift)

addSubview(bottomView)

在iOS14中,cell的contentView层级在cell上,如果直接将控件添加到cell上,点击的时候,只会响应下面的协议方法(swift)

tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath)

应该修改成(swift)

contentView.addSubview(bottomView)

Link:

iOS 插件开发及问题排查

iOS 插件开发及问题排查:

iOS新建应用和新建插件,默认都会把目标部署系统版本设置为最新操作系统版本,如果App没有找到应用或者插件,首先排查 minimum deployment target 是否匹配设备系统版本
  1. 排查App或者插件 最低支持版本是否对于设备操作系统版本。
  2. 检查 Build Phases > Embed App Extensions 是否包含指定插件,并且 Copy only when installing 是否为未选中状态。
  3. 检查插件运行后是否有崩溃。

Link:

clang: error: SDK does not contain 'libarclite' at the path

Apple staff mentions:

libarclite was necessary for older OS versions, but is now obsolete. If you're encountering errors referring to this library, you should audit every target in your project for those that declare support for a minimum deployment target under iOS 11, and update them to at least iOS 11, or something more recent than that. You should not modify your Xcode installation to resolve this.

In podfile: add these lines at the end of the file. This will automatically change all pods targets to iOS 11 after running pod install. You don't have to select each target step by step.

post_install do |installer|
  installer.pods_project.targets.each do |target|
    target.build_configurations.each do |config|
      config.build_settings["IPHONEOS_DEPLOYMENT_TARGET"] = "11.0"
    end
  end
end

bundleId 被注册错误提示及解决方案

如果bundleID 已经被其他账号注册,则会提示以下错误,需要换一个bundleid 或 让另一个账号进行删除:

Embedded binary's bundle identifier is not prefixed with the parent app's bundle identifier.

Python Conda macOS安装步骤:

brew install --cask anaconda
## setup conda environment
vim ~/.zshrc
export PATH="/opt/homebrew/anaconda3/bin:$PATH"
source ~/.zshrc
conda --version

## create empty environment
conda create -n py37 or conda create --name py37

## activate
conda activate py37 or source activate python3.7

## use x86_64 architecture channel(s)
conda config --env --set subdir osx-64

## install python, numpy, etc. (add more packages here...)
conda install python=3.7 numpy

## show all envs
conda info --envs

Link:

Mac开发记录

Mac 开发权限记录

在Mac开发中,如果需要申请权限才能运行,建议使用证书或账号(免费账号/收费账号)进行开发,否则使用(Sign To Run Locally)方式运行会导致每次代码改动后运行App都要重新进行授权(需要先删除上次的权限,再进行授权)

使用以下命令可以重置录屏屏幕权限
// 重置Mac App 权限设置
tccutil reset ScreenCapture com.xsir.packagename

Mac证书申请

2.1 Mac证书申请后,如果需要申请描述文件,需要导入Mac电脑的 UDID,添加 UDID 时注意选择为Mac平台,否则无法添加进描述文件。
Mac电脑的 UDID 获取方式:
option + 左上角菜单栏的苹果菜单,点击系统信息,在硬件概览里选择 预置UDID

2.2 Mac电脑证书导入,跟iOS 证书一致,都是导入P12文件。然后在 Provision Profile 中选择 Import Profile,之后就可以进行正常使用(通过描述文件对应证书)。

Note: 对于创建证书和描述文件的电脑,则为双击安装。如果安装后无法显示描述文件,需要重启Xcode再进行操作

Mac安装oh-my-zsh

Mac安装oh-my-zsh,可以提升Mac终端使用便利性,自动提示可以忽略大小写,安装官方教材如下:

https://ohmyz.sh/

目录

一、安装Ohmyzsh

1、执行命令:

2、手动安装

二、配置主题

三、配置插件

1、增加高亮插件zsh-syntax-highlighting

2、增加自动提示插件zsh-autosuggestions

四、推荐命令行工具

1、iterm2

2、hyper

官网:

Oh My Zsh - a delightful & open source framework for Zsh
https://ohmyz.sh/

一、安装Ohmyzsh

官网安装教程:Oh My Zsh - a delightful & open source framework for Zshzz
Oh-My-Zsh is a delightful, open source, community-driven framework for managing your ZSH configuration.
https://ohmyz.sh/#install

需要能连接到github(解决git clone超时问题见:

https://blog.csdn.net/CaptainJava/article/details/121119176
https://blog.csdn.net/CaptainJava/article/details/121119176

1、执行命令:

sh -c "$(curl -fsSL https://raw.github.com/ohmyzsh/ohmyzsh/master/tools/install.sh)"

2、手动安装

如果链接不到这个网址 可以通过浏览器打开这个地址,把内容报错下来,或者复制一下内容报错为install.sh:

#!/bin/sh
#
# This script should be run via curl:
#   sh -c "$(curl -fsSL https://raw.githubusercontent.com/ohmyzsh/ohmyzsh/master/tools/install.sh)"
# or via wget:
#   sh -c "$(wget -qO- https://raw.githubusercontent.com/ohmyzsh/ohmyzsh/master/tools/install.sh)"
# or via fetch:
#   sh -c "$(fetch -o - https://raw.githubusercontent.com/ohmyzsh/ohmyzsh/master/tools/install.sh)"
#
# As an alternative, you can first download the install script and run it afterwards:
#   wget https://raw.githubusercontent.com/ohmyzsh/ohmyzsh/master/tools/install.sh
#   sh install.sh
#
# You can tweak the install behavior by setting variables when running the script. For
# example, to change the path to the Oh My Zsh repository:
#   ZSH=~/.zsh sh install.sh
#
# Respects the following environment variables:
#   ZSH     - path to the Oh My Zsh repository folder (default: $HOME/.oh-my-zsh)
#   REPO    - name of the GitHub repo to install from (default: ohmyzsh/ohmyzsh)
#   REMOTE  - full remote URL of the git repo to install (default: GitHub via HTTPS)
#   BRANCH  - branch to check out immediately after install (default: master)
#
# Other options:
#   CHSH       - 'no' means the installer will not change the default shell (default: yes)
#   RUNZSH     - 'no' means the installer will not run zsh after the install (default: yes)
#   KEEP_ZSHRC - 'yes' means the installer will not replace an existing .zshrc (default: no)
#
# You can also pass some arguments to the install script to set some these options:
#   --skip-chsh: has the same behavior as setting CHSH to 'no'
#   --unattended: sets both CHSH and RUNZSH to 'no'
#   --keep-zshrc: sets KEEP_ZSHRC to 'yes'
# For example:
#   sh install.sh --unattended
# or:
#   sh -c "$(curl -fsSL https://raw.githubusercontent.com/ohmyzsh/ohmyzsh/master/tools/install.sh)" "" --unattended
#
set -e
 
# Track if $ZSH was provided
custom_zsh=${ZSH:+yes}
 
# Default settings
ZSH=${ZSH:-~/.oh-my-zsh}
REPO=${REPO:-ohmyzsh/ohmyzsh}
REMOTE=${REMOTE:-https://github.com/${REPO}.git}
BRANCH=${BRANCH:-master}
 
# Other options
CHSH=${CHSH:-yes}
RUNZSH=${RUNZSH:-yes}
KEEP_ZSHRC=${KEEP_ZSHRC:-no}
 
 
command_exists() {
  command -v "$@" >/dev/null 2>&1
}
 
# The [ -t 1 ] check only works when the function is not called from
# a subshell (like in `$(...)` or `(...)`, so this hack redefines the
# function at the top level to always return false when stdout is not
# a tty.
if [ -t 1 ]; then
  is_tty() {
    true
  }
else
  is_tty() {
    false
  }
fi
 
# This function uses the logic from supports-hyperlinks[1][2], which is
# made by Kat Marchán (@zkat) and licensed under the Apache License 2.0.
# [1] https://github.com/zkat/supports-hyperlinks
# [2] https://crates.io/crates/supports-hyperlinks
#
# Copyright (c) 2021 Kat Marchán
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
supports_hyperlinks() {
  # $FORCE_HYPERLINK must be set and be non-zero (this acts as a logic bypass)
  if [ -n "$FORCE_HYPERLINK" ]; then
    [ "$FORCE_HYPERLINK" != 0 ]
    return $?
  fi
 
  # If stdout is not a tty, it doesn't support hyperlinks
  is_tty || return 1
 
  # DomTerm terminal emulator (domterm.org)
  if [ -n "$DOMTERM" ]; then
    return 0
  fi
 
  # VTE-based terminals above v0.50 (Gnome Terminal, Guake, ROXTerm, etc)
  if [ -n "$VTE_VERSION" ]; then
    [ $VTE_VERSION -ge 5000 ]
    return $?
  fi
 
  # If $TERM_PROGRAM is set, these terminals support hyperlinks
  case "$TERM_PROGRAM" in
  Hyper|iTerm.app|terminology|WezTerm) return 0 ;;
  esac
 
  # kitty supports hyperlinks
  if [ "$TERM" = xterm-kitty ]; then
    return 0
  fi
 
  # Windows Terminal or Konsole also support hyperlinks
  if [ -n "$WT_SESSION" ] || [ -n "$KONSOLE_VERSION" ]; then
    return 0
  fi
 
  return 1
}
 
fmt_link() {
  # $1: text, $2: url, $3: fallback mode
  if supports_hyperlinks; then
    printf '\033]8;;%s\a%s\033]8;;\a\n' "$2" "$1"
    return
  fi
 
  case "$3" in
  --text) printf '%s\n' "$1" ;;
  --url|*) fmt_underline "$2" ;;
  esac
}
 
fmt_underline() {
  is_tty && printf '\033[4m%s\033[24m\n' "$*" || printf '%s\n' "$*"
}
 
# shellcheck disable=SC2016 # backtick in single-quote
fmt_code() {
  is_tty && printf '`\033[2m%s\033[22m`\n' "$*" || printf '`%s`\n' "$*"
}
 
fmt_error() {
  printf '%sError: %s%s\n' "$BOLD$RED" "$*" "$RESET" >&2
}
 
setup_color() {
  # Only use colors if connected to a terminal
  if is_tty; then
    RAINBOW="
      $(printf '\033[38;5;196m')
      $(printf '\033[38;5;202m')
      $(printf '\033[38;5;226m')
      $(printf '\033[38;5;082m')
      $(printf '\033[38;5;021m')
      $(printf '\033[38;5;093m')
      $(printf '\033[38;5;163m')
    "
    RED=$(printf '\033[31m')
    GREEN=$(printf '\033[32m')
    YELLOW=$(printf '\033[33m')
    BLUE=$(printf '\033[34m')
    BOLD=$(printf '\033[1m')
    RESET=$(printf '\033[m')
  else
    RAINBOW=""
    RED=""
    GREEN=""
    YELLOW=""
    BLUE=""
    BOLD=""
    RESET=""
  fi
}
 
setup_ohmyzsh() {
  # Prevent the cloned repository from having insecure permissions. Failing to do
  # so causes compinit() calls to fail with "command not found: compdef" errors
  # for users with insecure umasks (e.g., "002", allowing group writability). Note
  # that this will be ignored under Cygwin by default, as Windows ACLs take
  # precedence over umasks except for filesystems mounted with option "noacl".
  umask g-w,o-w
 
  echo "${BLUE}Cloning Oh My Zsh...${RESET}"
 
  command_exists git || {
    fmt_error "git is not installed"
    exit 1
  }
 
  ostype=$(uname)
  if [ -z "${ostype%CYGWIN*}" ] && git --version | grep -q msysgit; then
    fmt_error "Windows/MSYS Git is not supported on Cygwin"
    fmt_error "Make sure the Cygwin git package is installed and is first on the \$PATH"
    exit 1
  fi
 
  git clone -c core.eol=lf -c core.autocrlf=false \
    -c fsck.zeroPaddedFilemode=ignore \
    -c fetch.fsck.zeroPaddedFilemode=ignore \
    -c receive.fsck.zeroPaddedFilemode=ignore \
    -c oh-my-zsh.remote=origin \
    -c oh-my-zsh.branch="$BRANCH" \
    --depth=1 --branch "$BRANCH" "$REMOTE" "$ZSH" || {
    fmt_error "git clone of oh-my-zsh repo failed"
    exit 1
  }
 
  echo
}
 
setup_zshrc() {
  # Keep most recent old .zshrc at .zshrc.pre-oh-my-zsh, and older ones
  # with datestamp of installation that moved them aside, so we never actually
  # destroy a user's original zshrc
  echo "${BLUE}Looking for an existing zsh config...${RESET}"
 
  # Must use this exact name so uninstall.sh can find it
  OLD_ZSHRC=~/.zshrc.pre-oh-my-zsh
  if [ -f ~/.zshrc ] || [ -h ~/.zshrc ]; then
    # Skip this if the user doesn't want to replace an existing .zshrc
    if [ "$KEEP_ZSHRC" = yes ]; then
      echo "${YELLOW}Found ~/.zshrc.${RESET} ${GREEN}Keeping...${RESET}"
      return
    fi
    if [ -e "$OLD_ZSHRC" ]; then
      OLD_OLD_ZSHRC="${OLD_ZSHRC}-$(date +%Y-%m-%d_%H-%M-%S)"
      if [ -e "$OLD_OLD_ZSHRC" ]; then
        fmt_error "$OLD_OLD_ZSHRC exists. Can't back up ${OLD_ZSHRC}"
        fmt_error "re-run the installer again in a couple of seconds"
        exit 1
      fi
      mv "$OLD_ZSHRC" "${OLD_OLD_ZSHRC}"
 
      echo "${YELLOW}Found old ~/.zshrc.pre-oh-my-zsh." \
        "${GREEN}Backing up to ${OLD_OLD_ZSHRC}${RESET}"
    fi
    echo "${YELLOW}Found ~/.zshrc.${RESET} ${GREEN}Backing up to ${OLD_ZSHRC}${RESET}"
    mv ~/.zshrc "$OLD_ZSHRC"
  fi
 
  echo "${GREEN}Using the Oh My Zsh template file and adding it to ~/.zshrc.${RESET}"
 
  sed "/^export ZSH=/ c\\
export ZSH=\"$ZSH\"
" "$ZSH/templates/zshrc.zsh-template" > ~/.zshrc-omztemp
  mv -f ~/.zshrc-omztemp ~/.zshrc
 
  echo
}
 
setup_shell() {
  # Skip setup if the user wants or stdin is closed (not running interactively).
  if [ "$CHSH" = no ]; then
    return
  fi
 
  # If this user's login shell is already "zsh", do not attempt to switch.
  if [ "$(basename -- "$SHELL")" = "zsh" ]; then
    return
  fi
 
  # If this platform doesn't provide a "chsh" command, bail out.
  if ! command_exists chsh; then
    cat <<EOF
I can't change your shell automatically because this system does not have chsh.
${BLUE}Please manually change your default shell to zsh${RESET}
EOF
    return
  fi
 
  echo "${BLUE}Time to change your default shell to zsh:${RESET}"
 
  # Prompt for user choice on changing the default login shell
  printf '%sDo you want to change your default shell to zsh? [Y/n]%s ' \
    "$YELLOW" "$RESET"
  read -r opt
  case $opt in
    y*|Y*|"") echo "Changing the shell..." ;;
    n*|N*) echo "Shell change skipped."; return ;;
    *) echo "Invalid choice. Shell change skipped."; return ;;
  esac
 
  # Check if we're running on Termux
  case "$PREFIX" in
    *com.termux*) termux=true; zsh=zsh ;;
    *) termux=false ;;
  esac
 
  if [ "$termux" != true ]; then
    # Test for the right location of the "shells" file
    if [ -f /etc/shells ]; then
      shells_file=/etc/shells
    elif [ -f /usr/share/defaults/etc/shells ]; then # Solus OS
      shells_file=/usr/share/defaults/etc/shells
    else
      fmt_error "could not find /etc/shells file. Change your default shell manually."
      return
    fi
 
    # Get the path to the right zsh binary
    # 1. Use the most preceding one based on $PATH, then check that it's in the shells file
    # 2. If that fails, get a zsh path from the shells file, then check it actually exists
    if ! zsh=$(command -v zsh) || ! grep -qx "$zsh" "$shells_file"; then
      if ! zsh=$(grep '^/.*/zsh$' "$shells_file" | tail -1) || [ ! -f "$zsh" ]; then
        fmt_error "no zsh binary found or not present in '$shells_file'"
        fmt_error "change your default shell manually."
        return
      fi
    fi
  fi
 
  # We're going to change the default shell, so back up the current one
  if [ -n "$SHELL" ]; then
    echo "$SHELL" > ~/.shell.pre-oh-my-zsh
  else
    grep "^$USERNAME:" /etc/passwd | awk -F: '{print $7}' > ~/.shell.pre-oh-my-zsh
  fi
 
  # Actually change the default shell to zsh
  if ! chsh -s "$zsh"; then
    fmt_error "chsh command unsuccessful. Change your default shell manually."
  else
    export SHELL="$zsh"
    echo "${GREEN}Shell successfully changed to '$zsh'.${RESET}"
  fi
 
  echo
}
 
# shellcheck disable=SC2183  # printf string has more %s than arguments ($RAINBOW expands to multiple arguments)
print_success() {
  printf '%s         %s__      %s           %s        %s       %s     %s__   %s\n' $RAINBOW $RESET
  printf '%s  ____  %s/ /_    %s ____ ___  %s__  __  %s ____  %s_____%s/ /_  %s\n' $RAINBOW $RESET
  printf '%s / __ \%s/ __ \  %s / __ `__ \%s/ / / / %s /_  / %s/ ___/%s __ \ %s\n' $RAINBOW $RESET
  printf '%s/ /_/ /%s / / / %s / / / / / /%s /_/ / %s   / /_%s(__  )%s / / / %s\n' $RAINBOW $RESET
  printf '%s\____/%s_/ /_/ %s /_/ /_/ /_/%s\__, / %s   /___/%s____/%s_/ /_/  %s\n' $RAINBOW $RESET
  printf '%s    %s        %s           %s /____/ %s       %s     %s          %s....is now installed!%s\n' $RAINBOW $GREEN $RESET
  printf '\n'
  printf '\n'
  printf "%s %s %s\n" "Before you scream ${BOLD}${YELLOW}Oh My Zsh!${RESET} look over the" \
    "$(fmt_code "$(fmt_link ".zshrc" "file://$HOME/.zshrc" --text)")" \
    "file to select plugins, themes, and options."
  printf '\n'
  printf '%s\n' "• Follow us on Twitter: $(fmt_link @ohmyzsh https://twitter.com/ohmyzsh)"
  printf '%s\n' "• Join our Discord community: $(fmt_link "Discord server" https://discord.gg/ohmyzsh)"
  printf '%s\n' "• Get stickers, t-shirts, coffee mugs and more: $(fmt_link "Planet Argon Shop" https://shop.planetargon.com/collections/oh-my-zsh)"
  printf '%s\n' $RESET
}
 
main() {
  # Run as unattended if stdin is not a tty
  if [ ! -t 0 ]; then
    RUNZSH=no
    CHSH=no
  fi
 
  # Parse arguments
  while [ $# -gt 0 ]; do
    case $1 in
      --unattended) RUNZSH=no; CHSH=no ;;
      --skip-chsh) CHSH=no ;;
      --keep-zshrc) KEEP_ZSHRC=yes ;;
    esac
    shift
  done
 
  setup_color
 
  if ! command_exists zsh; then
    echo "${YELLOW}Zsh is not installed.${RESET} Please install zsh first."
    exit 1
  fi
 
  if [ -d "$ZSH" ]; then
    echo "${YELLOW}The \$ZSH folder already exists ($ZSH).${RESET}"
    if [ "$custom_zsh" = yes ]; then
      cat <<EOF
You ran the installer with the \$ZSH setting or the \$ZSH variable is
exported. You have 3 options:
1. Unset the ZSH variable when calling the installer:
   $(fmt_code "ZSH= sh install.sh")
2. Install Oh My Zsh to a directory that doesn't exist yet:
   $(fmt_code "ZSH=path/to/new/ohmyzsh/folder sh install.sh")
3. (Caution) If the folder doesn't contain important information,
   you can just remove it with $(fmt_code "rm -r $ZSH")
EOF
    else
      echo "You'll need to remove it if you want to reinstall."
    fi
    exit 1
  fi
 
  setup_ohmyzsh
  setup_zshrc
  setup_shell
 
  print_success
 
  if [ $RUNZSH = no ]; then
    echo "${YELLOW}Run zsh to try it out.${RESET}"
    exit
  fi
 
  exec zsh -l
}
 
main "$@"

然后给install.sh文件赋可执行权限

chmod +x install.sh

执行安装:

./install.sh

二、配置主题

自带主题示例:

https://github.com/ohmyzsh/ohmyzsh/wiki/Themes

默认主题目录:~/.oh-my-zsh/themes
自定义主题目录:~/.oh-my-zsh/custom/themes

自定义插件优先加载,如果没有再加载默认目录中的主题,建议自己下载的主题下载到自定义目录中

自带主题所在目录:

~/.oh-my-zsh/themes

设置方法:

修改配置文件

~/.zshrc

修改内容如下:

# 默认主题
# ZSH_THEME="robbyrussell"
# 随机主题
#ZSH_THEME="random"
 
ZSH_THEME="cloud"

也可以设置随机主题,每次开启窗口或者source是会自动切换,设置方式如下:

ZSH_THEME="random"

切换后会提示当前使用主题,如:

[oh-my-zsh] Random theme 'cloud' loaded

三、配置插件
说明:

默认插件目录:~/.oh-my-zsh/plugins
自定义插件目录:~/.oh-my-zsh/custom/plugins

自定义插件优先加载,如果没内有在加载默认目录中的插件,建议自己下载的插件下载到自定义目录中

以下插件可以通过手动git clone至插件目录或者通过一下命令

1、增加高亮插件zsh-syntax-highlighting

git clone https://github.com/zsh-users/zsh-syntax-highlighting.git ${ZSH_CUSTOM:-~/.oh-my-zsh/custom}/plugins/zsh-syntax-highlighting

修改~/.zshrc文件中配置:(插件间加空格)

plugins=(其他的插件 zsh-syntax-highlighting)
2、增加自动提示插件zsh-autosuggestions

git clone https://github.com/zsh-users/zsh-autosuggestions $ZSH_CUSTOM/plugins/zsh-autosuggestions

修改~/.zshrc文件中配置:

plugins=(其他的插件 zsh-autosuggestions)

最终:

plugins=(git zsh-autosuggestions zsh-syntax-highlighting per-directory-history command-not-found safe-paste history-substring-search)

插件推荐:mac上使用oh my zsh有哪些必备的插件推荐? - 知乎

四、推荐命令行工具

1、iterm2
2、hyper

Hyper™
A terminal built on web technologies
https://hyper.is/

Link: (mac安装ohmyzsh)[https://blog.csdn.net/CaptainJava/article/details/121117458]